#!/bin/bash
# Split out, so build_kernel.sh and build_deb.sh can share..

function linux-omap {
echo "Applying linux-omap-2.6.git's omap-$KERNEL_REL patchset"
if [ "${BISECT}" ] ; then
	git remote add -t omap-${KERNEL_REL} tmlind-omap-${KERNEL_REL} git://git.kernel.org/pub/scm/linux/kernel/git/tmlind/linux-omap-2.6.git
	git pull tmlind-omap-${KERNEL_REL} omap-${KERNEL_REL}
else
	patch -s -p1 < ${DIR}/patches/${BRANCH}-patch-from-${REL}-to-${GIT}.diff
	git add .
	git commit -a -m 'omap-merge'
fi
}

function musb {
echo "musb fifo fix"
patch -s -p1 < ${DIR}/patches/musb/musb-Add-new-fifo-table-for-a-OMAP3-errata.patch
patch -s -p1 < ${DIR}/patches/musb/enable-fifo_mode_5_for_OMAP34XX.diff
}

function angstrom {
echo "Angstrom Patches"
}

function micrel {
echo "micrel patches"
patch -s -p1 < ${DIR}/patches/micrel/ksz8851_snl_1_2.6.32.patch
patch -s -p1 < ${DIR}/patches/micrel/ksz8851_snl_2_2.6.32.patch
patch -s -p1 < ${DIR}/patches/micrel/ksz8851_snl_3_2.6.32.patch
patch -s -p1 < ${DIR}/patches/micrel/micrel-eth.patch
}

function rcn {
echo "rcn patches"
patch -s -p1 < ${DIR}/patches/rcn/ehci-omap-mach-to-plat-fix.diff
patch -s -p1 < ${DIR}/patches/rcn/Fix-i2c-lockup.diff
}

function dss2 {
echo "dss2 patches"
patch -s -p1 < ${DIR}/patches/rcn/beagle-dss2-support.diff
patch -s -p1 < ${DIR}/patches/rcn/beagle-enable-2nd-i2c.diff
}

function vfp {
echo "Apply vfp patches, should help pixman"
git am ${DIR}/patches/vfp/0001-So-far-vfp_sync_state-worked-only-for-threads-other-.patch
git am ${DIR}/patches/vfp/0002-Signal-handlers-can-use-floating-point-so-prevent-th.patch
}

function memory-hole {
echo "Applying memory hole patch"
git am ${DIR}/patches/omap/0001-ARCH-OMAP-enable-ARCH_HAS_HOLES_MEMORYMODEL-for-OMAP.patch
}

#linux-omap
musb
#rcn
dss2
vfp
#memory-hole

#enable micrel for zippy2 support
#micrel

